package com.tzld.piaoquan.recommend.server.util;

import org.apache.commons.collections4.CollectionUtils;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;

/**
 * @author dyp
 */
public class CommonCollectionUtils {
    public static <T, R> List<R> toList(List<T> list, Function<T, R> map) {
        if (CollectionUtils.isEmpty(list)) {
            return Collections.emptyList();
        }
        return list.stream().map(map).collect(Collectors.toList());
    }

    public static <T, R> List<R> toListDistinct(List<T> list, Function<T, R> map) {
        if (CollectionUtils.isEmpty(list)) {
            return Collections.emptyList();
        }
        return list.stream().map(map).distinct().collect(Collectors.toList());
    }


    public static <T, K, V> Map<K, V> toMap(Collection<T> col, Function<T, K> keyFunc, Function<T, V> valueFunc) {
        if (CollectionUtils.isEmpty(col)) {
            return Collections.emptyMap();
        }
        return col.stream().collect(Collectors.toMap(keyFunc::apply, valueFunc::apply));
    }

    public static <T> boolean contains(Collection<T> col, T ele) {
        if (CollectionUtils.isEmpty(col)) {
            return false;
        }
        return col.contains(ele);
    }
}
